import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;

public class Main {
	
	static String readFile(String path, Charset encoding) throws IOException{
		byte[] encoded = Files.readAllBytes(Paths.get(path));
		return new String(encoded, encoding);
	}
	
	public static void main(String[] args){
		String c_m = "";
		String alg = "";
		String pc = "";
		String pas_m = "";
		String fileC_m = "";
		String fileAlg = "";
		String filePc = "";
		String filePas_m = "";
		double avg_c_to_pc = 0;
		double avg_c_to_alg = 0;
		double avg_pas_to_alg = 0;
		try {
			for(int i = 1; i<=30 ; i++){
				if (i < 10){
					fileC_m = "dataset/c_ansi/alg_0" + i + "_m.c";
					fileAlg = "dataset/portugol/alg_0" + i + ".alg";
					filePc = "dataset/portucol/alg_0" + i + ".pc";
					filePas_m = "dataset/pascal/alg_0" + i + "_m.pas";
				} else {
					fileC_m = "dataset/c_ansi/alg_" + i + "_m.c";
					fileAlg = "dataset/portugol/alg_" + i + ".alg";
					filePc = "dataset/portucol/alg_" + i + ".pc";
					filePas_m = "dataset/pascal/alg_" + i + "_m.pas";
				}
				c_m = readFile(fileC_m, StandardCharsets.UTF_8);
				alg = readFile(fileAlg, StandardCharsets.UTF_8);
				pc = readFile(filePc, StandardCharsets.UTF_8);
				pas_m = readFile(filePas_m, StandardCharsets.UTF_8);
				double cosineCtoAlg = Cosine_Similarity.cosineSimilarityScore(c_m, alg);
				double cosineC_mtoPc = Cosine_Similarity.cosineSimilarityScore(c_m, pc);
				double cosinePastoAlg = Cosine_Similarity.cosineSimilarityScore(pas_m, alg);
				System.out.println("Cosine " + i + " -> PortuCol/C = " + cosineC_mtoPc + " --- Portugol/C = " + cosineCtoAlg);
				System.out.println("Cosine " + i + " -> PortuCol/C = " + cosineC_mtoPc + " --- Portugol/Pascal = " + cosinePastoAlg);
				avg_c_to_pc += cosineC_mtoPc;
				avg_c_to_alg += cosineCtoAlg;
				avg_pas_to_alg += cosinePastoAlg;
				
				System.out.println("");
			}
			avg_c_to_pc /= 30;
			avg_c_to_alg /= 30;
			avg_pas_to_alg /= 30;
			System.out.println("Avg C to Pc = " + avg_c_to_pc);
			System.out.println("Avg C to Alg = " + avg_c_to_alg);
			System.out.println("Avg Pas to Alg = " + avg_pas_to_alg);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
